DropDownMenuControl = class(Turbine.UI.Control)
function DropDownMenuControl:Constructor(parent, height)
    Turbine.UI.Control.Constructor(self)

    self.height = height

    self:SetParent(parent)
    self:SetVisible(false)
    self:SetSize(400, self.height)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self:SetZOrder(100)

    self.SelectionContainerPopOut = Turbine.UI.Control()
    self.SelectionContainerPopOut:SetParent(self)
    self.SelectionContainerPopOut:SetPosition(5, 5)
    self.SelectionContainerPopOut:SetSize(400 - 10, self.height - 10)
    self.SelectionContainerPopOut:SetMouseVisible(true)
    self.SelectionContainerPopOut:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    self.SelectionContainerPopOut:SetZOrder(100)

    self.PopOoutContainer = Turbine.UI.ListBox()
    self.PopOoutContainer:SetParent(self.SelectionContainerPopOut)
    self.PopOoutContainer:SetSize(380, self.height - 10)
    self.PopOoutContainer:SetPosition(0, 0)
    self.PopOoutContainer:SetVisible(true)
    self.PopOoutContainer:SetBackColor(GetRandomColour())
    self.PopOoutContainer:SetOrientation(Turbine.UI.Orientation.Vertical)

    self.ScrollbarBackground = Turbine.UI.Control()
    self.ScrollbarBackground:SetParent(self.SelectionContainerPopOut)
    self.ScrollbarBackground:SetPosition(380, 0)
    self.ScrollbarBackground:SetSize(10, self.height - 10)
    self.ScrollbarBackground:SetMouseVisible(false)
    self.ScrollbarBackground:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

    self.PopOoutContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.PopOoutContainerScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.PopOoutContainerScrollbar:SetParent(self.SelectionContainerPopOut)
    self.PopOoutContainerScrollbar:SetPosition(380, 0)
    self.PopOoutContainerScrollbar:SetSize(10, self.height - 10)
    self.PopOoutContainerScrollbar:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    self.PopOoutContainer:SetVerticalScrollBar( self.PopOoutContainerScrollbar)

    self.VisibleChanged = function()
        if self:IsVisible() then
            local x, y = self:GetMousePosition()
            local oldX, oldY = self:GetPosition()
            self:SetPosition((x + oldX) - 200, y + oldY + 5)
        end
    end
end

function DropDownMenuControl:AddItem(name, func)
    local ListItem = Turbine.UI.Control()
    ListItem:SetSize(380, 24)
    ListItem:SetMouseVisible(true)
    ListItem:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

    local BackGroundControl = Turbine.UI.Control()
    BackGroundControl:SetParent(ListItem)
    BackGroundControl:SetSize(380, 20)
    BackGroundControl:SetPosition(0, 2)
    BackGroundControl:SetMouseVisible(false)
    BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(ListItem)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    NameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    NameLabel:SetSize(380, 20)
    --NameLabel:SetPosition(0, 2)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetText(name)
    
    ListItem.MouseClick = function()
        func()
    end

    ListItem.MouseEnter = function()
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    end

    ListItem.MouseLeave = function()
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    end

    self.PopOoutContainer:AddItem(ListItem)
end

function DropDownMenuControl:ToggleVisible()
    self:SetVisible(not(self:IsVisible()))
end